program direct_dfbdfsb;

const MAXP=200;

var ile, H,is_vis: array[1..MAXP, 1..MAXP] of integer;
    r1,r2,c1,c2, p,q, d,id, i,j : integer;
    
procedure wczyt;
begin
  read(p, q);
  for i:=1 to p do begin
    for j:=1 to q do begin
      read(H[i,j]);
      is_vis[i,j] := -1;
      ile[i, j] := -1;
    end;
  end;    
  read(r1, c1, r2, c2);
end;

function max(a, b: integer):integer;
begin
  if a>b then max := a else max := b;
end;  

function vis_col(r1, c1, r2, c2: integer) : boolean;   {c2 > c1}
var rog, l, dc, dr, h1, h2, dy1, x, c, r, H0 : integer;
begin
  vis_col := false;
  dc := c2-c1; dr := r2-r1; h1 := H[r1, c1]; h2:= H[r2, c2];
  for c := c1 to c2-1 do begin
    dy1 := 2*(c-c1) + 1;
    l := dy1 * dr;
    x := 2*r1 - 1 + (l div dc);
    if (l mod dc=0) and (x mod 2=0) then rog := 1 else rog:=0;
    r := x div 2; H0 := 0;
    if rog=1 then begin
      if r1 < r2 then H0 := max(H[r, c], H[r+1, c+1]);
      if r2 < r1 then H0 := max(H[r+1, c], H[r, c+1]);
    end else begin
      H0 := max(H[r+1, c], H[r+1, c+1]);
    end;    
    if (dy1*(h2-h1) < (2*H0-2*h1-1)*dc) then exit;  
  end;
  vis_col := true;
end;

function vis_row(r1, c1, r2, c2 : integer) : boolean;   {r2 > r1}
var rog, l, dc, dr, h1, h2, dy1, x, c, r, H0 : integer;
begin
  vis_row := false;
  dc := c2-c1; dr := r2-r1; h1 := H[r1, c1]; h2:= H[r2, c2];
  for r := r1 to r2-1 do begin
    dy1 := 2*(r-r1) + 1;
    l := dy1 * dc;
    x := 2*c1 - 1 + (l div dr);
    if (l mod dr=0) and (x mod 2=0) then rog := 1 else rog:= 0;
    c := x div 2; H0 := 0;
    if rog=1 then begin
      if c1 < c2 then H0 := max(H[r, c], H[r+1, c+1]);
      if c2 < c1 then H0 := max(H[r+1, c], H[r, c+1]);
    end else begin
      H0 := max(H[r, c+1], H[r+1, c+1]);
    end;    
    if (dy1*(h2-h1) < (2*H0-2*h1-1)*dr) then exit;  
  end;
  vis_row := true;
end;

    
function visible(r1, c1, r2, c2 : integer) : boolean;
begin
  visible := false;  
  if c1 > c2 then if not vis_col(r2, c2, r1, c1) then exit;
  if c1 < c2 then if not vis_col(r1, c1, r2, c2) then exit;
  if r1 > r2 then if not vis_row(r2, c2, r1, c1) then exit;
  if r1 < r2 then if not vis_row(r1, c1, r2, c2) then exit;
  visible := true;
end;

function is_visible(i, j : integer) : boolean;
begin
  if is_vis[i, j] = -1 then 
    is_vis[i, j] := ord(visible(i, j, r1, c1) or visible(i, j, r2, c2));
  is_visible := is_vis[i,j] = 1;    
end;

var queue : array[1..MAXP*MAXP] of integer;
    q1, q2 : integer;

procedure init_q;
begin
  q1 := 1;
  q2 := 0;
end;

procedure add(i, j : integer);
begin
  if ((i<1)or(i>p)or(j<1)or(j>q)) then begin  
  writeln('bug add',i,' ',j);
  runerror;
  end;
  inc(q2); queue[q2] := 1000*i + j-1;
end;

procedure get(var i,j : integer);
begin
  i := queue[q1] div 1000;
  j := queue[q1] mod 1000+1;
  if ((i<1)or(i>p)or(j<1)or(j>q)) then begin  
  writeln('bug get ',i,' ',j,' ',q1,' ',q2);
  runerror;
  end;
  inc(q1);
end;

function empty_q: boolean;
begin
  empty_q := q2<q1;
end;  

var dh : integer;

procedure sprobuj(i1, j1: integer);
begin
  if ile[i1, j1] <> -1 then exit;
  dh := H[i1, j1] - H[i, j];
  if (dh <= 1) and (dh >= -3) and 
     (is_visible(i1, j1)) then begin
    add(i1, j1);
    ile[i1, j1] := ile[i, j] + 1;
  end;
end;

procedure bfs;
begin
  while (not empty_q) and (ile[r2,c2] <> -1) do begin
    get(i, j);
    if (i > 1) then sprobuj(i-1, j);
    if (i < p) then sprobuj(i+1, j);
    if (j > 1) then sprobuj(i, j-1);
    if (j < q) then sprobuj(i, j+1); 
  end;
end;

Begin
  readln(d); for id:=1 to d do begin
    wczyt;
    {writeln('sdfsdgf');}
    init_q;
    add(r1, c1); ile[r1, c1] := 0;
    bfs;
    if ile[r2,c2] = -1 then writeln('Mission impossible!')
      else writeln('The shortest path is ', ile[r2, c2], ' steps long.');
  end;
end.
