#include <stdio.h>

const int MAX = 128;
const int INF = 2000000000;

char NAMEK[MAX],NAMEL[MAX];
int Fr[MAX];

int T[MAX][MAX];
int Best[MAX][MAX];
int K,L;

void Read() {
  scanf("%d%d%s%s",&K,&L,NAMEK,NAMEL);
  for(int i=0;i<L;i++) scanf("%d",&Fr[i]);
}

void Calc() {
  int i,k,c,f,cost;
  T[0][0]=0;
  for(c=1;c<=L;c++) T[0][c]=INF;
   
  for(k=1;k<=K;k++)
  for(c=0;c<=L;c++) {
    T[k][c]=INF; f=cost=0; 
    for(i=c;i>=0;i--) {
      if(i!=c) { f+=Fr[i]; cost+=f; }
      if(T[k-1][i]!=INF && T[k-1][i]+cost <= T[k][c]) {
        Best[k][c]=i;
	T[k][c]=T[k-1][i]+cost;
      }
    }
  }
}

void Write() {
  int k,c;
  static int Kon[MAX];
  
  Kon[K]=L;
  for(k=K-1;k>=0;k--) Kon[k]=Best[k+1][Kon[k+1]];
  c=0;
  for(k=0;k<K;k++) {
    putchar(NAMEK[k]);
    printf(": ");
    for(;c<Kon[k+1];c++) putchar(NAMEL[c]);
    putchar('\n');
  }
  putchar('\n');
}

int main() {
  int T,i;
  scanf("%d",&T);
  for(i=0;i<T;i++) {
    Read();
    Calc();
    printf("Keypad #%d:\n",i+1);
    Write();
  }
  return 0;
}
